<?php
/**
 * PEAR Coding Standard.
 *
 * PHP version 5
 *
 * @category  PHP
 * @package   PHP_CodeSniffer
 * @author    Greg Sherwood <gsherwood@squiz.net>
 * @author    Marc McIntyre <mmcintyre@squiz.net>
 * @copyright 2006 Squiz Pty Ltd (ABN 77 084 670 600)
 * @license   http://matrix.squiz.net/developer/tools/php_cs/licence BSD Licence
 * @version   CVS: $Id: PEARCodingStandard.php,v 1.8 2008/11/17 05:04:07 squiz Exp $
 * @link      http://pear.php.net/package/PHP_CodeSniffer
 */

if (class_exists('PHP_CodeSniffer_Standards_CodingStandard', true) === false) {
    throw new PHP_CodeSniffer_Exception('Class PHP_CodeSniffer_Standards_CodingStandard not found');
}

/**
 * PEAR Coding Standard.
 *
 * @category  PHP
 * @package   PHP_CodeSniffer
 * @author    Greg Sherwood <gsherwood@squiz.net>
 * @author    Marc McIntyre <mmcintyre@squiz.net>
 * @copyright 2006 Squiz Pty Ltd (ABN 77 084 670 600)
 * @license   http://matrix.squiz.net/developer/tools/php_cs/licence BSD Licence
 * @version   Release: 1.2.0a1
 * @link      http://pear.php.net/package/PHP_CodeSniffer
 */
class PHP_CodeSniffer_Standards_Borealis_BorealisCodingStandard extends PHP_CodeSniffer_Standards_CodingStandard
{


    /**
     * Return a list of external sniffs to include with this standard.
     *
     * The PEAR standard uses some generic sniffs.
     *
     * @return array
     */
    public function getIncludedSniffs()
    {
        return array(
                'Generic/Sniffs/NamingConventions/UpperCaseConstantNameSniff.php',
                'Generic/Sniffs/PHP/LowerCaseConstantSniff.php',
                'Generic/Sniffs/PHP/DisallowShortOpenTagSniff.php',
                'Generic/Sniffs/WhiteSpace/DisallowTabIndentSniff.php',
				'Generic/Sniffs/Classes/DuplicateClassNameSniff.php',
                //'Generic/Sniffs/CodeAnalysis/EmptyStatementSniff.php', 
                'Generic/Sniffs/CodeAnalysis/ForLoopShouldBeWhileLoopSniff.php',
                'Generic/Sniffs/CodeAnalysis/ForLoopWithTestFunctionCallSniff.php',
                'Generic/Sniffs/CodeAnalysis/JumbledIncrementerSniff.php', 
                'Generic/Sniffs/CodeAnalysis/UnconditionalIfStatementSniff.php',
                'Generic/Sniffs/CodeAnalysis/UnnecessaryFinalModifierSniff.php',        
                'Generic/Sniffs/CodeAnalysis/UnusedFunctionParameterSniff.php',
                'Generic/Sniffs/CodeAnalysis/UselessOverridingMethodSniff.php',
                'Generic/Sniffs/Commenting/TodoSniff.php',
                'Generic/Sniffs/Strings/UnnecessaryStringConcatSniff.php',
                
				'PEAR/Sniffs/Classes/ClassDeclarationSniff.php',
				'PEAR/Sniffs/Commenting/FunctionCommentSniff.php',
				'PEAR/Sniffs/Commenting/InlineCommentSniff.php',
				//'PEAR/Sniffs/ControlStructures/ControlSignatureSniff.php',
				'PEAR/Sniffs/ControlStructures/InlineControlStructureSniff.php',
				//'PEAR/Sniffs/ControlStructures/MultiLineConditionSniff.php',
				'PEAR/Sniffs/Files/IncludingFileSniff.php',
				'PEAR/Sniffs/Formatting/MultiLineAssignmentSniff.php',
				'PEAR/Sniffs/Functions/FunctionCallArgumentSpacingSniff.php',
				'PEAR/Sniffs/Functions/FunctionCallSignatureSniff.php',
				'PEAR/Sniffs/Functions/FunctionDeclarationSniff.php',
				'PEAR/Sniffs/Functions/ValidDefaultValueSniff.php',				
				//'PEAR/Sniffs/NamingConventions/ValidFunctionNameSniff.php',
				//'PEAR/Sniffs/NamingConventions/ValidVariableNameSniff.php',
				'PEAR/Sniffs/WhiteSpace/ObjectOperatorIndentSniff.php',
				//'PEAR/Sniffs/WhiteSpace/ScopeClosingBraceSniff.php',
				//'PEAR/Sniffs/WhiteSpace/ScopeIndentSniff.php',
               );

    }//end getIncludedSniffs()


}//end class
?>
