<?php
/**
* Gestionnaire pour le controle ACL  
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-acl  
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Gestionnaire pour le controle ACL
* 
* @category   PHP 
* @package    Borealis-acl
* @subpackage Manager
* @author     Pascal Martin
*/
class com_borealis_acl_manager_ACLManager
{
    /**
    * Vérifie si l'utilisateur a le doit sur l'action de la ressource demander
    * 
    * @param string                            $pstrUsername  Utilisateur
    * @param com_borealis_acl_object_Ressource $pobjRessource Ressource
    * @param com_borealis_acl_object_Action    $pobjAction    Action
    * 
    * @return bool true or false
    */
    public static function isAuthorized($pstrUsername, com_borealis_acl_object_Ressource $pobjRessource, com_borealis_acl_object_Action $pobjAction)
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrUsername);
        
        return com_borealis_acl_datastore_DataStoreFactory::getDataStore()->isAuthorized($pstrUsername, $pobjRessource, $pobjAction);
    }  
    

}    

?>