<?php
/**
* Class for autoload the borealis package class
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-foundation  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/
      
/**
* Class for autoload the borealis package class
* 
* @category PHP 
* @package  Borealis-foundation
* @author   Pascal Martin
*/
class com_borealis_Autoload
{
    /**
    * Try loading php class
    * 
    * @param string $pstrName ClassName to load
    * 
    * @return boolean true if loaded false otherwise
    */
    static public function load($pstrName) 
    {         
        $objArrayPath = explode('_', $pstrName);
        $strPath = implode('/', $objArrayPath).".php";
        
        try        
        {
            include $strPath;
        }
        catch(Exception $objError)
        {
            return false;   
        }
        return true;
    }
}

spl_autoload_register(array('com_borealis_Autoload', 'load')); 

?>