<?php
/**
* Method d'assertion
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-foundation  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/
 
/**
* Method d'assertion  
* 
* @category   PHP 
* @package    Borealis-foundation
* @subpackage Util
* @author     Pascal Martin 
*/
class com_borealis_foundation_util_Assert
{
    /**
    * Vrifie que le paramtre est une string
    * 
    * @param mixed $pstrValue Valeur a vrifier
    * 
    * @throws com_borealis_foundation_exception_AssertException
    * 
    * @return void
    */
    static public function assertIsString($pstrValue) 
    {
        if (is_string($pstrValue) === false)
        {
            throw new com_borealis_foundation_exception_AssertException("$pstrValue is not a string");    
        }
    } 
    
    /**
    * Vrifie que le paramtre est une string non vide
    * 
    * @param mixed $pstrValue Valeur a vrifier
    * 
    * @throws com_borealis_foundation_exception_AssertException
    * 
    * @return void
    */
    static public function assertIsNotEmptyString($pstrValue)
    {
        self::assertIsString($pstrValue);
        if (strlen($pstrValue) === 0)
        {
            throw new com_borealis_foundation_exception_AssertException("$pstrValue is a empty string"); 
        }
    } 
    
    /**
    * Vrifie que le paramtre est un integer
    * 
    * @param mixed $pstrValue Valeur a vrifier
    * 
    * @throws com_borealis_foundation_exception_AssertException
    * 
    * @return void
    */
    static public function assertIsInteger($pstrValue) 
    {
        try
        {
            if (is_integer($pstrValue) === false)
            {
                throw new com_borealis_foundation_exception_AssertException("$pstrValue is not a integer");    
            }
        }
        catch(Exception $objError)
        {
            throw new com_borealis_foundation_exception_AssertException("is not a integer");    
        }
    }   
}
  
?>
