<?php
/**
* Fichier de configuration du package Borealis-security
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Fichier de configuration du package Borealis-security 
* 
* @category PHP 
* @package  Borealis-security
* @author   Pascal Martin 
*/ 
abstract class com_borealis_security_Setting
{
    // --------------------------------------------------------------------------
    // Josso manager configuration
    // --------------------------------------------------------------------------
    const JOSSO_ENDPOINT = 'http://localhost:9997';
    
    const JOSSO_GATEWAY_LOGIN = 'http://localhost:9997/josso/signon/login.do';
    
    const JOSSO_AUTHENTICATION_SECURITYDOMAIN = 'josso';
    const JOSSO_AUTHORIZATION_SECURITYDOMAIN = 'josso'; 
    const JOSSO_AUTHORIZATION_PASSWORD = 'empty';   
    const JOSSO_PROPERTY_SECURITYDOMAIN = 'josso';
    const JOSSO_PROPERTY_PASSWORD = 'empty';
    
    // WS client configuration : 
    const JOSSO_WS_DEFAULT_SOCKET_TIMEOUT = '2';
    
    const JOSSO_WS_SSO_SESSIONMANAGER = '/josso/services/SSOSessionManager?wsdl';
    const JOSSO_WS_SSO_IDENTITYMANAGER = '/josso/services/SSOIdentityManager?wsdl';                                                                        
    const JOSSO_WS_SSO_IDENTITYPROVIDER = '/josso/services/SSOIdentityProvider?wsdl'; 
    
    // --------------------------------------------------------------------------
    // XML manager configuration
    // --------------------------------------------------------------------------
    const XML_CONFIG_FILE = 'M:\projects\php\borealis-security\main\src\com\borealis\security\security.xml';
    
    // --------------------------------------------------------------------------
    // Authentication provider
    // --------------------------------------------------------------------------
    const AUTHENTICATION_MANAGER = 'com_borealis_security_manager_impl_josso_JossoManager';
      
    // --------------------------------------------------------------------------
    // Authorization provider
    // --------------------------------------------------------------------------
    const AUTHORIZATION_MANAGER = 'com_borealis_security_manager_impl_josso_JossoManager';
    
    // --------------------------------------------------------------------------
    // Property provider
    // --------------------------------------------------------------------------
    const PROPERTY_MANAGER = 'com_borealis_security_manager_impl_josso_JossoManager';    
}
  
?>
