<?php 
/**
* Classe de base qui reprsente un session sso
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-security  
* @author    Pascal Martin 
* @copyright Boral Informations Stratgiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Classe de base qui reprsente un session sso
* 
* @category   PHP 
* @package    Borealis-security
* @subpackage Session
* @author     Pascal Martin 
*/ 
abstract class com_borealis_security_session_SSOSession extends com_borealis_security_session_Session
{
    private $m_strToken;
    
    /**
    * Construit une nouvelle instance de com_borealis_security_session_SSOSession 
    * 
    * @param string $pstrUsername Nom d'utilisateur
    * @param string $pstrToken    Token  
    * 
    * @throws com_borealis_security_IllegalArgumentException
    * 
    * @return com_borealis_security_session_SSOSession
    */
    function __construct($pstrUsername, $pstrToken) 
    {
        parent::__construct($pstrUsername);
        
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrToken);
        $this->m_strToken = $pstrToken;  
    }

    /**
    * Retourne le token lier  la session
    * 
    * @return string SSO Session token  
    */
    public function getToken()
    {
        return $this->m_strToken;        
    }    
}   
    
?>