<?php    
/**
* Lance les test Copy Paste Detector (CPD)  
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-test  
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

require_once dirname(__FILE__).'/../Setting.php';
require_once dirname(__FILE__).'/../SettingImpl.php';

if (isset($_SERVER['argv']) && count($_SERVER['argv']) === 4)
{
    $_REQUEST['testpath'] = $_SERVER['argv'][1];
    $_REQUEST['minimumtoken'] = $_SERVER['argv'][2];
    $_REQUEST['display'] = $_SERVER['argv'][3];
}

if (strcmp('', trim($_REQUEST['testpath']))===0)
{
    die('Directory or file to test are empty');
}

if (!isset($_REQUEST['minimumtoken']) || $_REQUEST['minimumtoken'] === '')
{
    $_REQUEST['minimumtoken'] = 200;      
}

if (!is_numeric($_REQUEST['minimumtoken']))
{
    die('Not integer minimum-token');   
}

if (!isset($_REQUEST['display']))
{
    $_REQUEST['display'] == '';
}

if (isset($_REQUEST['display']) && $_REQUEST['display'] !== '')
{
    $_REQUEST['display'] = '--format '. $_REQUEST['display'];     
}

header("Content-Type: text/plain");


$g_strResult = shell_exec(com_borealis_test_SettingImpl::getPMDLib()."/bin/cpd.bat --minimum-tokens $_REQUEST[minimumtoken] $_REQUEST[display] --language php --files $_REQUEST[testpath] --encoding iso-8859-1");       

if ($_REQUEST['display'] === '--format net.sourceforge.pmd.cpd.XMLRenderer')
{
    $g_strResult = str_replace('Cp1252', 'iso-8859-1', $g_strResult);
   
    // Suppression des warning de comment
    try 
    {
        $objDomDocument = new DOMDocument();
        $objDomDocument->loadXML($g_strResult);
        
        $objXPath = new DOMXpath($objDomDocument);
        $objDomNodeListDuplication = $objXPath->query('/pmd-cpd/duplication');
        
        foreach ($objDomNodeListDuplication as $objDomNodeDuplication)
        { 
            $objDomNodeListCodeFragment = $objXPath->query('./codefragment', $objDomNodeDuplication);
            
            foreach ($objDomNodeListCodeFragment as $objDomNodeCodeFragment)
            {                
                if (preg_match('/^((\*.*)|(\*\/)|(\/\*\*)|( *)|(\r)|(\n))+$/', $objDomNodeCodeFragment->nodeValue))
                {
                    $objDomNodeCodeFragment->parentNode->parentNode->removeChild($objDomNodeCodeFragment->parentNode); 
                }
            }
        }
        $objDomDocument->preserveWhiteSpace = false;
        $g_strResult = $objDomDocument->saveXML();
    }
    catch (Exception $objError) 
    { 
        // ne rien faire 
    }     
}    
echo $g_strResult;

?>
