<?php   
/**
* Classe de base qui représente un mot de passe
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-authentication
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

/**
* Classe de base qui représente un mot de passe
* 
* @category   PHP 
* @package    Borealis-authentication
* @subpackage Password
* @author     Pascal Martin 
*/
abstract class com_borealis_authentication_password_Password
{
    private $m_strValue;
    
    /**
    * Construit une nouvelle instance de com_borealis_security_Password 
    * 
    * @param string $pstrValue Password value in raw text
    * 
    * @throws com_borealis_security_exception_IllegalArgumentException
    * 
    * @return com_borealis_security_Password
    */
    function __construct($pstrValue) 
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrValue);
        
        $this->m_strValue = $pstrValue;
    }

    /**
    * Retourne la valeur du mot de passe
    * 
    * @return string Password value  
    */
    public function getValue()
    {
        return $this->m_strValue;        
    }    
}   
    
?>