<?php
 
// -----------------------------------------------
// --- Step 1 : Mettre la source de borealis-authentication et borealis-foundation disponible dans le classe path
// -----------------------------------------------
set_include_path('.;../../main/src;../../../borealis-foundation/main/src'); 

// -----------------------------------------------
// --- Step 2 : Inclure la classe responsable du chargement des autre classe (com/borealis/Autoload)
// -----------------------------------------------
require_once 'com/borealis/Autoload.php';      
require_once 'M:/lib/php/Smarty-2.6.22/libs/Smarty.class.php'; // Optionnel si vous n'utilier par Smarty comme générateur de view

// -----------------------------------------------
// --- Step 3 : Configurer la library borealis-authentication, l'ui indiquer la liste des checher (Serveur d'authentification ou méthode d'authentification)
// -----------------------------------------------

// ---- Constructeur de Password (Password = class qui encode le mot de passe dans le bon format)
// ----
// Createur de mot de passe en texte claire
$objRawPasswordCreator = new com_borealis_authentication_password_RawPasswordCreator(); 

// Créateur de mot de passe qui encode le mot de passe en md5
$objMD5PasswordCreator = new com_borealis_authentication_password_MD5PasswordCreator(); 

// Créateur de mot de passe qui encode le mot de passe dans le même format que la v2
$objV2PasswordCreator = new com_borealis_authentication_password_V2PasswordCreator(); 

// ---- Checker (Serveur d'authentification ou méthode d'authentification)
// ----
// Checker qui vérifie les droits de connexion par un serveur Alfresco
$g_strAlfrescoUrl = 'http://192.168.5.121:8081/alfresco/service/api/login.xml';
$g_objAlfrescoChecker1 = new com_borealis_authentication_checker_AlfrescoChecker($objRawPasswordCreator, $g_strAlfrescoUrl);
$g_objAlfrescoChecker2 = new com_borealis_authentication_checker_AlfrescoChecker($objMD5PasswordCreator, $g_strAlfrescoUrl);

// Checker qui vérifie les droits de connexion par un serveur JOSSO
$g_strJossoUrl = 'http://192.168.5.121:9997/josso/services/SSOIdentityProvider?wsdl';
$g_strJossoSecurityDomain = 'josso';
$g_objJossoChecker1 = new com_borealis_authentication_checker_JossoChecker($objRawPasswordCreator, $g_strJossoUrl, $g_strJossoSecurityDomain);
$g_objJossoChecker2 = new com_borealis_authentication_checker_JossoChecker($objV2PasswordCreator, $g_strJossoUrl, $g_strJossoSecurityDomain);

// Checker qui vérifie les droits de connexion par un serveur LDAP
$g_strLDAPHostname = '192.168.1.39'; 
$g_iLDAPPort = 389;      
$g_strLDAPSearchDN = 'ou=People,dc=boreal-is,dc=com';  
$g_strLDAPUsernameColumn = 'uid';        
$g_strLDAPArrayOptions = array(LDAP_OPT_PROTOCOL_VERSION => 3); 
$g_objLDAPChecker = new com_borealis_authentication_checker_LdapChecker($objRawPasswordCreator, $g_strLDAPHostname, $g_iLDAPPort, $g_strLDAPSearchDN, $g_strLDAPUsernameColumn, $g_strLDAPArrayOptions) ;          

// Checker qui vérifie les droits de connexion par une BD
$g_strPDODSN = 'pgsql:host=192.168.5.121;port=5432;dbname=qa_application;user=postgres;password=postgres';
$g_strPDOQuery = 'select users_id from users where users_login = :username and users_password = :password';
$g_objPDOChecker1 = new com_borealis_authentication_checker_PDOChecker($objRawPasswordCreator, $g_strPDODSN, $g_strPDOQuery);
$g_objPDOChecker2 = new com_borealis_authentication_checker_PDOChecker($objV2PasswordCreator, $g_strPDODSN, $g_strPDOQuery);


// Checker qui vérifie les droits de connexion par un fichier XML
$g_strXMLFILE = dirname(__FILE__).'/users.xml';
$g_objXMLChecker1 = new com_borealis_authentication_checker_XMLChecker($objRawPasswordCreator, $g_strXMLFILE);
$g_objXMLChecker2 = new com_borealis_authentication_checker_XMLChecker($objMD5PasswordCreator, $g_strXMLFILE);

// ---- com_borealis_authentication_SettingImpl setCheckers (Permet d'indiquer la liste des Checker qui serons utiliser par le com_borealis_authentication_AuthenticationManager)
// ----
// You can set one checker
com_borealis_authentication_SettingImpl::setCheckers(array($g_objAlfrescoChecker1));
// Or more than one checker (All checker are call and if one return true the result is true)
com_borealis_authentication_SettingImpl::setCheckers(array($g_objXMLChecker1, $g_objPDOChecker1));


// -----------------------------------------------
// --- Step 4 : Test if user is authorized to login
// -----------------------------------------------
$bIsAuthorized = com_borealis_authentication_AuthenticationManager::isAuthorized('Username','Password');
if ($bIsAuthorized)
{
    // You are Authorized 
    //   Save in session one variable to say you are Authorized for not call checker on each session call
    //   Show you securer page 
}
else
{
    // You are not Authorized  
    //   Show the login page
}

// -----------------------------------------------
// --- Step 5+ : Optional for this sample test library only
// -----------------------------------------------

$objArrayCheck = array( 
                        array('username' => 'admin', 'password' => 'admin'),
                        array('username' => 'admin', 'password' => 'carotte'),
                        array('username' => 'admin', 'password' => 'bW1tbW1tbW1tbW1tbW1tbbV54bDhE7IE6YAJmOz4Qn4='),                        
                        array('username' => 'pmartin', 'password' => 'bingo'),
                        array('username' => 'pmartin', 'password' => 'admin'),
                        array('username' => 'pmartin', 'password' => '3a3795bb61d5377545b4f345ff223e3d'),
                        array('username' => 'pmartin', 'password' => 'tomatte'),
                        array('username' => 'authuser', 'password' => 'Z!33iLi42'),
                        array('username' => 'god', 'password' => 'god'),
                        array('username' => 'god', 'password' => 'bad'),
                        array('username' => 'dag', 'password' => 'god'),
                        array('username' => 'guest', 'password' => 'guest'),
                       );

$objArrayChecker = array( 
                          array( 'name' => 'Alfresco 1', 'passwordType' => 'Raw', 'checker' => array($g_objAlfrescoChecker1)),
                          array( 'name' => 'Alfresco 2', 'passwordType' => 'MD5', 'checker' => array($g_objAlfrescoChecker2)),
                          
                          array( 'name' => 'Josso 1', 'passwordType' => 'Raw', 'checker' => array($g_objJossoChecker1)),
                          array( 'name' => 'Josso 2', 'passwordType' => 'V2', 'checker' => array($g_objJossoChecker2)),
                          
                          array( 'name' => 'LDAP 1', 'passwordType' => 'Raw', 'checker' => array($g_objLDAPChecker)),
                          
                          array( 'name' => 'PDO 1', 'passwordType' => 'Raw', 'checker' => array($g_objPDOChecker1)),
                          array( 'name' => 'PDO 2', 'passwordType' => 'V2', 'checker' => array($g_objPDOChecker2)),
                          
                          array( 'name' => 'XML 1', 'passwordType' => 'Raw', 'checker' => array($g_objXMLChecker1)),
                          array( 'name' => 'XML 2', 'passwordType' => 'MD5', 'checker' => array($g_objXMLChecker2)),
                          
                          array( 'name' => 'All', 'passwordType' => 'Mixed', 'checker' => array($g_objAlfrescoChecker1, $g_objAlfrescoChecker2, $g_objJossoChecker1, $g_objJossoChecker2, $g_objLDAPChecker, $g_objPDOChecker1, $g_objPDOChecker2, $g_objXMLChecker1, $g_objXMLChecker2))
                          );
$g_objResult = array();
foreach($objArrayCheck as $objCheck)
{
    $objResult = array();
    for($i=0;$i<count($objArrayChecker);++$i)
    {
        com_borealis_authentication_SettingImpl::setCheckers($objArrayChecker[$i]['checker']);
        $bIsAuthorized = com_borealis_authentication_AuthenticationManager::isAuthorized($objCheck['username'],$objCheck['password']);
        array_push($objResult, $bIsAuthorized);
    }
    array_push($g_objResult, $objResult);
}


// -----------------------------------------------
// --- Smarty display
// -----------------------------------------------
$objSmarty = new Smarty();

$objSmarty->template_dir = dirname(__FILE__).'/smarty/templates';
$objSmarty->compile_dir  = dirname(__FILE__).'/smarty/templates_c';
$objSmarty->compile_check = true;

$objSmarty->assign('objResult', $g_objResult); 
$objSmarty->assign('objArrayChecker', $objArrayChecker);
$objSmarty->assign('objArrayCheck', $objArrayCheck);  
$objSmarty->assign('iDoubleChecker', count($objArrayChecker)*2);     
                                    
if (!is_dir($objSmarty->compile_dir))
{
    mkdir($objSmarty->compile_dir); 
}
 
$objSmarty->display('authorized.tpl');
 
?>
