<?
       
class com_borealis_authentication_checker_AlfrescoCheckerTest extends PHPUnit_Framework_TestCase
{
    public static function getChecker()
    {
        return new com_borealis_authentication_checker_AlfrescoChecker(new com_borealis_authentication_password_RawPasswordCreator(), com_borealis_authentication_SettingImpl::ALFRESCO_CHECKER_URL);
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testConstruct()
    {
        $objChecker = self::getChecker();
        $this->assertTrue( $objChecker instanceof com_borealis_authentication_checker_Checker);
    }
       
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('authuser', 'Z!33iLi42');
        $this->assertTrue($bAuthorized);
        $bAuthorized = $objChecker->isAuthorized('pmartin', 'admin');        
        $this->assertTrue($bAuthorized);
        $bAuthorized = $objChecker->isAuthorized('admin', 'admin');
        $this->assertTrue($bAuthorized);
        session_start();
        $bAuthorized = $objChecker->isAuthorized('admin', 'admin');
        $this->assertTrue($bAuthorized);
        $this->assertTrue(isset($_SESSION['ALFRESCO_TICKET']));
        $this->assertTrue($_SESSION['ALFRESCO_TICKET'] != '');
        $bAuthorized = $objChecker->isAuthorized('admin', 'adminasasas');
        $this->assertFalse($bAuthorized);
        $this->assertTrue(!isset($_SESSION['ALFRESCO_TICKET']));
        $this->assertTrue(isset($_SESSION['ALFRESCO_TICKET_REASON']));
        $this->assertTrue($_SESSION['ALFRESCO_TICKET_REASON'] != '');
        session_destroy();
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized2()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('admin', 'adminasdasdas');
        $this->assertFalse($bAuthorized);
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized3()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('', 'adminasdasdas');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized4()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', '');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized5()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', 456);
    }
    
    /**  
    * @expectedException Exception
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized6()
    {
        $objChecker = new com_borealis_authentication_checker_AlfrescoChecker(new com_borealis_authentication_password_RawPasswordCreator(), 'asjasijf') ;          

        $bAuthorized = $objChecker->isAuthorized('sdfds', 'asdad');
    }
    
    /**  
    * @expectedException Exception
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized7()
    {
        $objChecker = new com_borealis_authentication_checker_AlfrescoChecker(new com_borealis_authentication_password_RawPasswordCreator(), 'www.google.ca') ;          

        $bAuthorized = $objChecker->isAuthorized('sdfds', 'asdad');
    }
       
}   
    
?>