<?
       
class com_borealis_authentication_checker_JossoCheckerTest extends PHPUnit_Framework_TestCase
{
    public static function getChecker()
    {
        return new com_borealis_authentication_checker_JossoChecker(new com_borealis_authentication_password_RawPasswordCreator(), com_borealis_authentication_SettingImpl::JOSSO_CHECKER_URL, com_borealis_authentication_SettingImpl::JOSSO_CHECKER_SECURITYDOMAIN);
    }
    
    public static function getChecker2()
    {
        return new com_borealis_authentication_checker_JossoChecker(new com_borealis_authentication_password_V2PasswordCreator(), com_borealis_authentication_SettingImpl::JOSSO_CHECKER_URL, com_borealis_authentication_SettingImpl::JOSSO_CHECKER_SECURITYDOMAIN);
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testConstruct()
    {
        $objChecker = self::getChecker();
        $this->assertTrue( $objChecker instanceof com_borealis_authentication_checker_Checker);
    }
       
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized()
    {
        $objChecker = self::getChecker();                 
        $bAuthorized = $objChecker->isAuthorized('admin', 'bW1tbW1tbW1tbW1tbW1tbbV54bDhE7IE6YAJmOz4Qn4=');
        $this->assertTrue($bAuthorized);
        session_start();
        $bAuthorized = $objChecker->isAuthorized('admin', 'bW1tbW1tbW1tbW1tbW1tbbV54bDhE7IE6YAJmOz4Qn4=');
        $this->assertTrue($bAuthorized);
        $this->assertTrue(isset($_SESSION['JOSSO_TOKEN']));
        $this->assertTrue($_SESSION['JOSSO_TOKEN'] != '');
        $bAuthorized = $objChecker->isAuthorized('admin', 'adminasasas');
        $this->assertFalse($bAuthorized);
        $this->assertTrue(!isset($_SESSION['JOSSO_TOKEN']));
        $this->assertTrue(isset($_SESSION['JOSSO_TOKEN_REASON']));
        $this->assertTrue($_SESSION['JOSSO_TOKEN_REASON'] != '');   
        session_destroy();
    }
    
    /**
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized2()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('admin', 'adminasdasdas');
        $this->assertFalse($bAuthorized);
        $objChecker = self::getChecker2();
        $bAuthorized = $objChecker->isAuthorized('admin', 'admin');
        $this->assertTrue($bAuthorized);
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized3()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('', 'adminasdasdas');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized4()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', '');
    }
    
    /**
    * @expectedException com_borealis_foundation_exception_AssertException 
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized5()
    {
        $objChecker = self::getChecker();
        $bAuthorized = $objChecker->isAuthorized('sdfds', 456);
    }
    
    /**  
    * @author Pascal Martin
    * @test
    */
    public function testIsAuthorized6()
    {
        $objChecker = new com_borealis_authentication_checker_JossoChecker(new com_borealis_authentication_password_RawPasswordCreator(), 'asjasijf', 'as') ;          

        $bAuthorized = $objChecker->isAuthorized('sdfds', 'asdad');
        $this->assertFalse($bAuthorized);
    }          
}   
    
?>