<?php
/**
* Classe qui stoke les informations d'un utilisateur
*
* PHP versions 5
* 
* @category  PHP
* @package   Borealis-users  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.boreal-is.com/license BSD License
* @link      http://www.boreal-is.com
*/

/**
* Classe qui stoke les informations d'un utilisateur         
* 
* @category PHP 
* @package  Borealis-users
* @author   Pascal Martin 
*/  
class com_borealis_users_User
{
    private $m_strUsername = null;
    private $m_strName = null;
    
    /**
    * Constructeur de la classe com_borealis_users_User
    * 
    * @param string $pstrName     Prénom et nom de l'utilisateur
    * @param string $pstrUsername Nom d'utilisateur (Login name)
    * 
    * @return com_borealis_users_User
    */
    public function __construct($pstrName, $pstrUsername) 
    {        
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrName);
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrUsername);
        
        $this->m_strUsername = $pstrUsername;
        $this->m_strName = $pstrName;
    }
    
    /**
    * Retourne le nom de l'utilisateur   
    * 
    * @return string
    */
    public function getName()
    {
        return $this->m_strName;
    } 
    
    /**
    * Retourne le nom d'utilisateur (Login name)
    * 
    * @return string
    */
    public function getUsername()
    {
        return $this->m_strUsername;
    }   
} 
  
?>