<?php
/**
* Fichier php pour le l'affichage de la section qui présente la matrice des permissions d'un utilisateur
*
* PHP versions 5
* 
* @category  PHP
* @package   ACL
* @author    Pascal Martin 
* @copyright Boréal Informations Stratégiques Inc.
* @license   http://www.boreal-is.com/license Borealis License
* @link      http://www.boreal-is.com
*/

// -----------------------------------------------
// --- Include
// -----------------------------------------------
require_once 'common.php'; 

// -----------------------------------------------
// --- Set domain
// -----------------------------------------------
bindtextdomain("useracl", $g_strLanguageDir);
textdomain("useracl"); 
bind_textdomain_codeset("useracl", "UTF-8");

// -----------------------------------------------
// --- Variable global
// -----------------------------------------------
$g_strUsername = null; 
$g_strErrorUserAcl = '';
$g_objArrayUserPermission = array(); 

// -----------------------------------------------
// --- Action
// -----------------------------------------------

/**
* Construit l'array $g_objArrayRolePermission qui est utiliser par le tpl
* Contient tous les ressources auquel le user a droit ainsi que l'information sur ces droit 
* 
* @return void
*/
function userACL()
{
    global $g_strErrorUserAcl;
    global $g_strUsername;
    global $g_objArrayUserPermission;
    
    if (!isset($_REQUEST['username']) || trim($_REQUEST['username']) == '' )
    {
        $g_strErrorUserAcl = gettext('error_empty_username');
        return;    
    }
    
    $g_strUsername = trim($_REQUEST['username']);
    
    $objArrayRoles = com_borealis_acl_object_Role::getAll();
    $objArrayActions = com_borealis_acl_object_Action::getAll();
    
    $objArrayTemplate =  array();
    foreach ($objArrayActions as $objAction)
    {
        $strActionName = $objAction->getName();
        $objArrayTemplate[$strActionName] = false;       
    }
    
    $objRole = null;
    foreach ($objArrayRoles as $objRole)
    {
        if (in_array($g_strUsername, (array)$objRole->getMember()))
        {
            foreach ($objRole->getPermission() as $objArrayPermission)
            {
                $objRessource = $objArrayPermission['ressource'];
                $objAction = $objArrayPermission['action'];
                if (!isset($g_objArrayUserPermission[$objRessource->getName()]))
                {
                    $g_objArrayUserPermission[$objRessource->getName()] = array( 'right' => $objArrayTemplate, 'roles' => array());   
                } 
                $strActionName = $objAction->getName();
                $g_objArrayUserPermission[$objRessource->getName()]['right'][$strActionName] = true;
                if (!in_array($objRole->getName(), $g_objArrayUserPermission[$objRessource->getName()]['roles']))
                {
                     $g_objArrayUserPermission[$objRessource->getName()]['roles'][] = $objRole->getName();       
                }                
            }       
        }
    }
    foreach ($g_objArrayUserPermission as $strRessource => $objArrayPermission)
    {
        $objRessource = com_borealis_acl_object_Ressource::getByName($strRessource);
        $g_objArrayUserPermission[$strRessource]['enabled'] = $objArrayTemplate;
        foreach ($objRessource->getActions() as $objAction)
        {
            $g_objArrayUserPermission[$strRessource]['enabled'][$objAction->getName()] = true;
        }         
    }
}
    
if (isset($_REQUEST['action']))
{   
    switch($_REQUEST['action'])
    {
        case 'useracl':
            userACL();
            break;
    }
}

// -----------------------------------------------
// --- Smarty display
// -----------------------------------------------
$g_objSmarty->assign('actions', com_borealis_acl_object_Action::getAll());
$g_objSmarty->assign('username', $g_strUsername); 
$g_objSmarty->assign('errorUserAcl', $g_strErrorUserAcl); 
$g_objSmarty->assign('objArrayUserPermission', $g_objArrayUserPermission);                                                  
                                                                                              
$g_objSmarty->display('useracl.tpl');
  
?>