<?php

header('Content-type: application/json; charset=UTF-8');  

$strCurrentDir = dirname(__FILE__);

$g_objArrayCat = array();


function scanSample($pstrDir)
{
    foreach (new DirectoryIterator($pstrDir) as $fileInfo) 
    {
        if($fileInfo->isDot())
        {
            continue;        
        }
        else if($fileInfo->isDir())
        {
            findSample($fileInfo->getPathname(), $fileInfo->getFilename());
        }
    }
}

function findSample($pstrDir, $pstrDirName)
{
    global $g_objArrayCat;
    foreach (new DirectoryIterator($pstrDir) as $fileInfo) 
    {
        if($fileInfo->isDot())
        {
            continue;        
        }
        else if($fileInfo->isDir())
        {
            findSample($fileInfo->getPathname(), $pstrDirName."_".$fileInfo->getFilename());
        }
        else if($fileInfo->isFile() && $fileInfo->getFilename() == 'sample.php' )  
        {
            try
            {
                include_once "$pstrDir/sample.php";
                $strClassName = "sample_$pstrDirName";
                $strClassName = str_replace('-','_', $strClassName);   
                if (class_exists($strClassName))                
                {        
                    $objArrayDataKey = array('cat', 'text', 'url', 'icon', 'desc', 'status', 'xml', 'xslt', 'doc');
                    $objArrayData = array();
                    
                    foreach($objArrayDataKey as $strKey)
                    {
                        $strMethodName = 'get'.$strKey;
                        if (method_exists($strClassName, $strMethodName))
                        {        
                            $objArrayData[$strKey] = call_user_func(array($strClassName, $strMethodName));
                        }
                    }

                    if ( isset($objArrayData['cat']))
                    {
                        $strCat = $objArrayData['cat'];
                        if (!isset( $g_objArrayCat[$strCat]))
                        {
                            $g_objArrayCat[$strCat] = array( "id" => 'sample-'.count($g_objArrayCat) , "title" => $strCat, "samples" => array());      
                        }
                        unset($objArrayData['cat']);
                        array_push($g_objArrayCat[$strCat]['samples'], $objArrayData);
                    }
                }
            }
            catch(Exception $e)
            {
                // vide  
            }
        }
    }
}

scanSample("$strCurrentDir/../../../../samples");



echo json_encode( array("samples" => array_values($g_objArrayCat)));

?>