<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009-2012 Mapgears Inc.
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:applyfilter="http://geoprisma.org/applyfilter"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="applyfilter:printWidgetSource">

    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/resources/css/ApplyFilter.css</xsl:text>
      </xsl:attribute>
    </link>

    <!-- JS 'gxp' -->
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/gxp.data.WFSProtocolProxy.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/gxp.data.WFSFeatureStore.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/gxp.grid.FeatureGrid.js</xsl:text>
      </xsl:attribute>    
    </script>

    <!-- JS 'org.GeoPrisma' -->
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.Manager.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.MessagePanel.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.Resource.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.SLDSetter.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.TabPanelContainer.js</xsl:text>
      </xsl:attribute>    
    </script>
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/applyfilter/lib/org.GeoPrisma.ApplyFilter.WFSFeatureGrid.js</xsl:text>
      </xsl:attribute>    
    </script>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
      <script>
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_widgets_url"/>
          <xsl:text>/applyfilter/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>

    <xsl:variable name="widgetType">
      <xsl:text>applyfilter</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$widgetType" />DrawComponents = [];
    </script>
    
   </xsl:template>

  <xsl:template name="applyfilter:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="widgetType">
      <xsl:text>applyfilter</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      var resource, objGPWidget<xsl:value-of select="$pWidgetName" />;

      <!-- Manager creation -->
      var widgetOptions = Ext.applyIf({
          mapPanel: objGPWidgetMapPanel<xsl:value-of select="$pMapName" />,
          proxyURL: '<xsl:value-of select="$proxyurl" />'
      }, 
      <xsl:for-each select="./options">
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>
      </xsl:for-each>);

      objGPWidget<xsl:value-of select="$pWidgetName" /> =
          new org.GeoPrisma.ApplyFilter.Manager(widgetOptions);

      <!-- Manage resources -->
      <xsl:for-each select="./resources/resource">
        <xsl:variable name="resourceName">
          <xsl:value-of select="." />
        </xsl:variable>

        <!-- In order to work with this widget, a resource must have one
             'wms' DataStore and one 'wfs' DataStore -->
        <xsl:variable name="wmsServiceType">
          <xsl:text>wms</xsl:text>
        </xsl:variable>
        <xsl:variable name="wfsServiceType">
          <xsl:text>wfs</xsl:text>
        </xsl:variable>

        <xsl:variable name="wmsDataStoreName">
          <xsl:call-template name="getDataStoreInfoFromWidget">
            <xsl:with-param name="pWidgetName" select="$pWidgetName" />
            <xsl:with-param name="pServiceType" select="$wmsServiceType" />
            <xsl:with-param name="pNodeName"><xsl:text>name</xsl:text></xsl:with-param>
            <xsl:with-param name="pResourceName" select="$resourceName"/>
          </xsl:call-template>
        </xsl:variable>
       <xsl:variable name="wfsDataStoreName">
          <xsl:call-template name="getDataStoreInfoFromWidget">
            <xsl:with-param name="pWidgetName" select="$pWidgetName" />
            <xsl:with-param name="pServiceType" select="$wfsServiceType" />
            <xsl:with-param name="pNodeName"><xsl:text>name</xsl:text></xsl:with-param>
            <xsl:with-param name="pResourceName" select="$resourceName"/>
          </xsl:call-template>
        </xsl:variable>

       <xsl:if test="$wmsDataStoreName != '' and $wfsDataStoreName != ''">

         <!-- wfsLayerName -->
         <xsl:variable name="wfsLayerName">
           <xsl:call-template name="getDataStoreInfoFromWidget">
             <xsl:with-param name="pWidgetName" select="$pWidgetName" />
             <xsl:with-param name="pServiceType" select="$wfsServiceType" />
             <xsl:with-param name="pNodeName"><xsl:text>params/layers</xsl:text></xsl:with-param>
             <xsl:with-param name="pResourceName" select="$resourceName"/>
           </xsl:call-template>
         </xsl:variable>

         <!-- wfsServiceName -->
         <xsl:variable name="wfsServiceName">
           <xsl:call-template name="getDataStoreInfoFromWidget">
             <xsl:with-param name="pWidgetName" select="$pWidgetName" />
             <xsl:with-param name="pServiceType" select="$wfsServiceType" />
             <xsl:with-param name="pNodeName"><xsl:text>service</xsl:text></xsl:with-param>
             <xsl:with-param name="pResourceName" select="$resourceName"/>
           </xsl:call-template>
         </xsl:variable>

         <!-- wmsLayerName -->
         <xsl:variable name="wmsLayerName">
           <xsl:call-template name="getDataStoreInfoFromWidget">
             <xsl:with-param name="pWidgetName" select="$pWidgetName" />
             <xsl:with-param name="pServiceType" select="$wmsServiceType" />
             <xsl:with-param name="pNodeName"><xsl:text>params/layers</xsl:text></xsl:with-param>
             <xsl:with-param name="pResourceName" select="$resourceName"/>
           </xsl:call-template>
         </xsl:variable>

         <xsl:for-each select="/geoprisma/resources/resource[./name = $resourceName]">
           <!-- getWFSDescribeFeatureType response text -->
           <xsl:variable name="wfsDescribeFeatureType">
             <xsl:value-of select="php:functionString('applyfilter::getWFSDescribeFeatureType',$resourceName)"></xsl:value-of>
           </xsl:variable>

           <!-- getWMSStyles response text -->
           <xsl:variable name="getWMSStyles">
             <xsl:value-of select="php:functionString('applyfilter::getWMSStyles',$resourceName)"></xsl:value-of>
           </xsl:variable>

           <!-- resource options -->
           <xsl:variable name="resourceOptions">
             <xsl:for-each select="./options">
               <xsl:call-template name="getObjectFromNode">
                 <xsl:with-param name="pNode" select="." />
               </xsl:call-template>
             </xsl:for-each>
           </xsl:variable>

           <!-- getText is used to escape the text -->
           resource = {
               name: '<xsl:value-of select="$resourceName" />',
               title: <xsl:for-each select="./title"><xsl:call-template name="getText" /></xsl:for-each>,
               options: <xsl:value-of select="$resourceOptions" />,
               wfsDescribeFeatureTypeResponseText : <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($wfsDescribeFeatureType), 'nodomain', 'JS')" />,
               wfsLayerName: '<xsl:value-of select="$wfsLayerName" />',
               wfsServiceName: '<xsl:value-of select="$wfsServiceName" />',
               wmsGetStylesResponseText : <xsl:value-of select="php:functionString('org_geoprisma_locale_Locale::getText', string($getWMSStyles), 'nodomain', 'JS')" />,
               wmsLayerName: '<xsl:value-of select="$wmsLayerName" />',
               fields: {}
           };
           <!-- todo, manage fields to get titles -->
           <xsl:for-each select="./fields/field">
             resource.fields['<xsl:value-of select="name" />'] = Ext.applyIf({
                 title: <xsl:for-each select="title" ><xsl:call-template name="getText" /></xsl:for-each>
             },
             <xsl:for-each select=".">
               <xsl:call-template name="getObjectFromNode">
                 <xsl:with-param name="pNode" select="." />
               </xsl:call-template>
             </xsl:for-each>);
           </xsl:for-each> <!-- foreach fields end-->
         </xsl:for-each> <!-- foreach resources/resource end -->

         objGPWidget<xsl:value-of select="$pWidgetName" />.manageResource(resource);
         objGPWidget<xsl:value-of select="$widgetType" />DrawComponents.push(
             objGPWidget<xsl:value-of select="$pWidgetName" />.getDrawComponent()
         );
       </xsl:if>
      </xsl:for-each> <!-- foreach widget resource end -->
      
   </script>
  </xsl:template>

  <xsl:template name="applyfilter:drawWidgets">
    <xsl:param name="pContainer" />

    <xsl:variable name="widgetType">
      <xsl:text>applyfilter</xsl:text>
    </xsl:variable>

    <xsl:variable name="nWidgets">
      <xsl:value-of select="count(/geoprisma/widgets/widget[./type = $widgetType])" />
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="$nWidgets = 0"></xsl:when>
      <xsl:when test="$nWidgets = 1">
        var drawComponent = objGPWidget<xsl:value-of select="$widgetType" />DrawComponents[0];

        if (typeof(<xsl:value-of select="$pContainer" />) != 'undefined' &amp;&amp; drawComponent) {
            if(<xsl:value-of select="$pContainer" /> instanceof Ext.Container){
                <xsl:value-of select="$pContainer" />.add(drawComponent);
            } else {
                <xsl:value-of select="$pContainer" />.items.push(drawComponent);
            }
        }
      </xsl:when>
      <xsl:otherwise>
        alert('Error: only one instance of "ApplyFilter" widget is currently supported.  Found : <xsl:value-of select="$nWidgets" />');
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>
</xsl:stylesheet>
