<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009-2011 Mapgears Inc.
   Published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 

<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:editfeature_confirm="http://geoprisma.org/editfeature_confirm"
    extension-element-prefixes="dyn">
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <xsl:template name="editfeature_confirm:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>editfeature_confirm</xsl:text>
    </xsl:variable>

    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/editfeature/EditFeature.js</xsl:text>
      </xsl:attribute>
    </script>

    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/editfeature/confirm/lib/org.GeoPrisma.EditFeature.Confirm.js</xsl:text>
      </xsl:attribute>
    </script>

    <!-- i18n -->
    <xsl:if test="$g_locale = 'fr_CA'">
      <script>
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_widgets_url"/>
          <xsl:text>/editfeature/confirm/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>

  </xsl:template>

  <xsl:template name="editfeature_confirm:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>editfeature_confirm</xsl:text>
    </xsl:variable>

    <!-- This widget supports this servicetype only-->
    <xsl:variable name="pServiceType">
      <xsl:text>featureserver</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      <xsl:for-each select="./resources/resource">

        <xsl:variable name="resourceName">
          <xsl:value-of select="." />
        </xsl:variable>

        <xsl:for-each select="/geoprisma/widgets/widget[./resources/resource = $resourceName]">
          <xsl:variable name="widgetType">
            <xsl:choose>
              <xsl:when test="./type = 'editfeature_create'">1</xsl:when>
              <xsl:when test="./type = 'editfeature_update'">1</xsl:when>
              <xsl:when test="./type = 'editfeature_copy'">2</xsl:when>
              <xsl:when test="./type = 'editfeature_drag'">2</xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>

          <xsl:variable name="addConfirmWidget">
            <xsl:choose>
              <xsl:when test="$widgetType = 1">
                <xsl:choose>
                  <xsl:when test="./options//featurepanel">0</xsl:when>
                  <xsl:otherwise>1</xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:when test="$widgetType = 2">
                <xsl:choose>
                  <xsl:when test="./options/toggleEdit">0</xsl:when>
                  <xsl:otherwise>1</xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>0</xsl:otherwise>
            </xsl:choose>
          </xsl:variable>

          <xsl:choose>
            <xsl:when test="$addConfirmWidget = 1">
              var objGPWidget<xsl:value-of select="pWidgetName" /><xsl:value-of select="$resourceName" />;
              objGPWidget<xsl:value-of select="$pMapName"/>.events.on({"printallwidgetexecutions": function(event) {
                  objGPWidget<xsl:value-of select="pWidgetName" /><xsl:value-of select="$resourceName" /> = new org.GeoPrisma.EditFeature.Confirm({
                      "editFeature": objGPWidget<xsl:value-of select="./name" /><xsl:value-of select="$resourceName" />
                  });
              }});
            </xsl:when>
            <xsl:otherwise>0</xsl:otherwise>
          </xsl:choose>

        </xsl:for-each><!-- for each widgets -->

      </xsl:for-each><!-- for each reesources -->
    </script>

    <script type="text/javascript">
    </script>
  </xsl:template>

</xsl:stylesheet>
