<?php
/* 
   Copyright (c) 2011- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license. 
*/ 
  
class EditFeature_Copy extends org_geoprisma_widget_WidgetBase
{
    static public function getText($pstrMsg, $pstrType = null)
    {
        return parent::getText($pstrMsg, self::getType(), $pstrType);
    }

    static public function getAction()
    {
        return 'create';
    }    
     
    static public function getType()
    {
        return 'editfeature_copy';
    }

    static public function getServiceType()
    {
        return 'featureserver';
    }

    static public function needLayer() 
    {
        return true;
    }

    static public function getMandatoryResourceOptionList()
    {
        return array('editable');
    }

    static public function getOptionalResourceOptionList()
    {
        return null;
    }

    static public function mustClone()
    {
        return false;
    }

    static public function linkResource($pobjResource, $pobjWidget) 
    {
        $strThisType = "copy";

        if ($pobjResource == null || $pobjWidget == null) 
        {
            return false;
        }

        $objArrayEditTypes = array();

        $objEditTypeOption = $pobjResource->getOption('editType', true);
        if ($objEditTypeOption !== false)
        {
            array_push($objArrayEditTypes, $objEditTypeOption->getValue());
        }
        else
        {
            $objEditTypesOption = $pobjResource->getOption('editTypes', true);
            if ($objEditTypesOption !== false)
            {
                $objArrayEditTypes = $objEditTypesOption->getValue();
            }
        }

        if (count($objArrayEditTypes) == 0)
        {
            $bLink = true;
        }
        else
        {
            $bLink = false;
            foreach ($objArrayEditTypes as $iKey => $strEditType)
            {
                if ($strEditType == $strThisType)
                {
                    $bLink = true;
                    break;
                }
            }
        }
        
        return $bLink;
    }
}
  
?>
