<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2010- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoextux_layertreebuilder="http://geoprisma.org/geoextux_layertreebuilder"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="geoextux_layertreebuilder:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_layertreebuilder</xsl:text>
    </xsl:variable>

    <!-- GeoExt.ux.LayerTreeBuilder source -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layertreebuilder/lib/GeoExt.ux/plugins/LayerTreeBuilderNodeAgent.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layertreebuilder/lib/GeoExt.ux/widgets/tree/LayerTreeBuilder.js</xsl:text>
        </xsl:attribute>
    </script>
    
    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/geoext-ux-layertreebuilder/resources/css/LayerTreeBuilder.css</xsl:text>
      </xsl:attribute>
    </link>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
        <script>
            <xsl:attribute name="src" >
                 <xsl:value-of select="$g_lib_url"/>
                 <xsl:text>/geoext-ux-layertreebuilder/resources/lang/fr.js</xsl:text>
            </xsl:attribute>
        </script>
    </xsl:if>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />Container = [];
      var objGPWidget<xsl:value-of select="$WidgetType" />DefaultOptions = {
        autoScroll: true,
        rootVisible: false,
        border: false,
        lines: false
      };
    </script>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="geoextux_layertreebuilder:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_layertreebuilder</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$pWidgetName" />;

      Ext.onReady(function() {
          oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
    
          var objWidgetOptions = Ext.applyIf(
            <xsl:for-each select="./options">
              <xsl:call-template name="getObjectFromNode">
                <xsl:with-param name="pNode" select="." />
              </xsl:call-template>
            </xsl:for-each>,
            objGPWidget<xsl:value-of select="$WidgetType" />DefaultOptions
          );

          objGPWidget<xsl:value-of select="$pWidgetName" /> = 
              new GeoExt.ux.tree.LayerTreeBuilder(objWidgetOptions);

          objGPWidget<xsl:value-of select="$WidgetType" />Container.push(
              objGPWidget<xsl:value-of select="$pWidgetName" />
          );
      });
    </script>

  </xsl:template>
  <!-- printWidgetExecution END  -->

  <!-- drawWidgets START  -->
  <xsl:template name="geoextux_layertreebuilder:drawWidgets">
    <xsl:param name="pContainer" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_layertreebuilder</xsl:text>
    </xsl:variable>
	if (typeof(objGPWidget<xsl:value-of select="$WidgetType" />Container) != 'undefined' &amp;&amp; typeof(<xsl:value-of select="$pContainer" />) != 'undefined')
    {
        for (var i=0, len=objGPWidget<xsl:value-of select="$WidgetType" />Container.length; i&lt;len; i++) {
            if(<xsl:value-of select="$pContainer" />['ctype']){
                <xsl:value-of select="$pContainer" />.add(
                    objGPWidget<xsl:value-of select="$WidgetType" />Container[i]
                );
            } else {
                <xsl:value-of select="$pContainer" />.items.push(
                    objGPWidget<xsl:value-of select="$WidgetType" />Container[i]
                )
            }
        }
    }
  </xsl:template>
  <!-- drawWidgets END  -->


</xsl:stylesheet>
