<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2011- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<!--
   NOTE: this widget uses GeoExt.MapPanel.guess() to get the
   GeoExt.MapPanel object is using the XMLConfig or XMLWorkspaceConfig driver.
-->
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoextux_printpreview="http://geoprisma.org/geoextux_printpreview"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="geoextux_printpreview:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_printpreview</xsl:text>
    </xsl:variable>

    <!-- source files from lib directory -->
    <link rel="stylesheet" type="text/css">
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/geoext-ux/ux/PrintPreview/resources/css/printpreview.css</xsl:text>    
      </xsl:attribute>
    </link>
    <script type="text/javascript">
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/geoext-ux/ux/PrintPreview/lib/GeoExt.ux/PrintPreview.js</xsl:text>
      </xsl:attribute>
    </script>
    <xsl:if test="$g_locale = 'fr_CA'">
      <script type="text/javascript">
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_lib_url"/>
          <xsl:text>/geoext-ux/ux/PrintPreview/lib/locale/PrintPreview-fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>

    <!-- source files from widget directory -->
    <script>
      <xsl:attribute name="src" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/geoextux/printpreview/PrintPreviewAction.js</xsl:text>
      </xsl:attribute>
    </script>

    <!-- i18n : "fr_CA" -->
    <xsl:if test="$g_locale = 'fr_CA'">
      <script>
        <xsl:attribute name="src" >
          <xsl:value-of select="$g_widgets_url"/>
          <xsl:text>/geoextux/printpreview/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
      </script>
    </xsl:if>

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="geoextux_printpreview:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_printpreview</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
        oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
        var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;
        <xsl:variable name="mapfishPrintService">
          <xsl:value-of select="./options/servicename" />
        </xsl:variable>

        var printCapabilities = <xsl:value-of select="php:functionString('geoextux_printpreview::getPrintCapabilitiesWithProxyURL',$mapfishPrintService)"></xsl:value-of>;

        <!-- make sure some of the objects returned are arrays -->
        if (printCapabilities.scales.scale) {
            var objScale = printCapabilities.scales.scale;
            printCapabilities.scales = [];
            printCapabilities.scales.push(objScale);
        }
        if (printCapabilities.dpis.dpi) {
            var objDpi = printCapabilities.dpis.dpi;
            printCapabilities.dpis = [];
            printCapabilities.dpis.push(objDpi);
        }
        if (printCapabilities.layouts.layout) {
            var objLayout = printCapabilities.layouts.layout;
            printCapabilities.layouts = [];
            printCapabilities.layouts.push(objLayout);
        }

        <!-- PrintProvider -->
        var printProvider = new GeoExt.data.PrintProvider({
            method: "POST",
            capabilities: printCapabilities,
            customParams: {
                mapTitle: "Printing Demo"
            }
        });

        <xsl:choose>
          <xsl:when test="count(/geoprisma/widgets/widget[./type = 'mappanel']) > 0">
            var mapPanel = objGPWidgetMapPanel<xsl:value-of select="$pMapName"/>;
          </xsl:when>
          <xsl:otherwise>
            var mapPanel;
          </xsl:otherwise>
        </xsl:choose>;

        var objGPWidget<xsl:value-of select="$pWidgetName" /> = new GeoExt.ux.PrintPreviewAction({
            "mapPanel": mapPanel,
            "printCapabilities": printCapabilities
        });

        objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions =
            objGPWidget<xsl:value-of select="$pWidgetName" />;
    </script>

  </xsl:template>
  <!-- printWidgetExecution END  -->

</xsl:stylesheet>
