<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Mapgears Inc., published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:geoextux_redliningpanel="http://geoprisma.org/geoextux_redliningpanel"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

  <!-- printWidgetSource START  -->
  <xsl:template name="geoextux_redliningpanel:printWidgetSource">
    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_redliningpanel</xsl:text>
    </xsl:variable>

    <!-- Lang -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/resources/lang/fr.js</xsl:text>
        </xsl:attribute>
    </script>

    <!-- GeoExt.ux.FeatureEditing source -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/FeatureEditingControler.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/form/FeatureEditingPanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/form/RedLiningPanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/form/FeaturePanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/data/FeatureEditingDefaultStyleStore.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/plugins/ImportFeatures.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/plugins/ExportFeatures.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/plugins/ExportFeature.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-featureediting/ux/widgets/plugins/CloseFeatureDialog.js</xsl:text>
        </xsl:attribute>
    </script>
    
    <!-- CSS -->
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_lib_url"/>
        <xsl:text>/geoext-ux-featureediting/resources/css/feature-editing.css</xsl:text>
      </xsl:attribute>
    </link>

    <script type="text/javascript">
      var objGPWidget<xsl:value-of select="$WidgetType" />GeoExtToolbarOptions;
      var objGPWidget<xsl:value-of select="$WidgetType" />Container;
    </script>

  <!-- GeoExt.ux.LayerManager source START  -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/downloadify/js/swfobject.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/downloadify/js/downloadify.min.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/utils/flash.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/data/FormatStore.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/data/Export.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/data/Import.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/widgets/LayerManagerExportPanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/widgets/LayerManagerImportPanel.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/widgets/LayerManagerWindow.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-layermanager/ux/widgets/LayerManagerExportWindow.js</xsl:text>
        </xsl:attribute>
    </script>
  <!-- GeoExt.ux.LayerManager source END  -->

  <!-- GeoExt.ux.StyleSelectorComboBox source START  -->
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-styler/ux/LayerStyleManager.js</xsl:text>
        </xsl:attribute>
    </script>
    <script>
        <xsl:attribute name="src" >
             <xsl:value-of select="$g_lib_url"/>
             <xsl:text>/geoext-ux-styler/ux/widgets/StyleSelectorComboBox.js</xsl:text>
        </xsl:attribute>
    </script>
  <!-- GeoExt.ux.StyleSelectorComboBox source END  -->

   </xsl:template>
  <!-- printWidgetSource END  -->

  <!-- printWidgetExecution START  -->
  <xsl:template name="geoextux_redliningpanel:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_redliningpanel</xsl:text>
    </xsl:variable>

    <script type="text/javascript">
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;
      var objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions;

      <!-- nWidgets : to get the number of this widget in a GeoExtToolbar -->
      <xsl:variable name="nWidgets">
        <xsl:variable name="XPathExpression">
          <xsl:text>count(/geoprisma/widgets/widget[./type='geoexttoolbar']/options/widgets[./widget='</xsl:text>
          <xsl:value-of select="$pWidgetName" />
          <xsl:text>'])</xsl:text>
        </xsl:variable>
        <xsl:value-of select="dyn:evaluate($XPathExpression)" />
      </xsl:variable>

      <!-- bInToolbar : set to 'true' if this widget is in a toolbar -->
      <xsl:variable name="bInToolbar">
        <xsl:choose>
          <xsl:when test="$nWidgets >= 1">true</xsl:when>
	  <xsl:otherwise>false</xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      var objWidgetOptions = {};
      <xsl:for-each select="./options">
        objWidgetOptions =
        <xsl:call-template name="getObjectFromNode">
          <xsl:with-param name="pNode" select="." />
        </xsl:call-template>;
      </xsl:for-each>
      objWidgetOptions['map'] = oMap;
      <!-- Bind 'vectorlayer' widget START -->
      <xsl:variable name="addVectorLayer">
        <xsl:if test="./options/vectorlayer">
          <xsl:variable name="vectorLayer">
            <xsl:value-of select="./options/vectorlayer" />
          </xsl:variable>
          <xsl:if test="//geoprisma/widgets/widget[./name = $vectorLayer]">
            if (window.objGPWidget<xsl:value-of select="$vectorLayer" />) {
                objWidgetOptions.layers = [window.objGPWidget<xsl:value-of select="$vectorLayer" />];
            } else {
                objWidgetOptions['cosmetic'] = true;
            }
          </xsl:if>
        </xsl:if>
      </xsl:variable>
      <xsl:choose>
        <xsl:when test="$addVectorLayer != ''">
          <xsl:value-of select="$addVectorLayer" />
        </xsl:when>
        <xsl:otherwise>objWidgetOptions['cosmetic'] = true;</xsl:otherwise>
      </xsl:choose>
      <!-- Bind 'vectorlayer' widget END -->

      <!-- "printallwidgetexecutions" callback method for this widget -->
      var onPrintAllWidgetExecutions = function(event) {
          var layer, i, iLen;
          for (i=0, iLen=this.layers.length; i&lt;iLen; i++) {
              layer = this.layers[i];
              this.map.setLayerIndex(layer, this.map.layers.length);
          }
      };

      <!-- Widget object creation -->
      var objGPWidget<xsl:value-of select="$pWidgetName" /> =
      <xsl:choose>
        <xsl:when test="$bInToolbar = 'true'">
          new GeoExt.ux.FeatureEditingControler(objWidgetOptions);
      objGPWidget<xsl:value-of select="$pWidgetName" />GeoExtToolbarOptions =
          objGPWidget<xsl:value-of select="$pWidgetName" />.actions;
      <!-- move cosmetic layer to top after "printallwidgetexecutions" -->
      if (objWidgetOptions['cosmetic'] === true) {
          objGPWidget<xsl:value-of select="$pMapName" />.events.on({
              "printallwidgetexecutions": onPrintAllWidgetExecutions,
              scope: objGPWidget<xsl:value-of select="$pWidgetName" />
          });
      }
        </xsl:when>
        <xsl:otherwise>
          new GeoExt.ux.form.RedLiningPanel(objWidgetOptions);
      <!-- move cosmetic layer to top after "printallwidgetexecutions" -->
      if (objWidgetOptions['cosmetic'] === true) {
          objGPWidget<xsl:value-of select="$pMapName" />.events.on({
              "printallwidgetexecutions": onPrintAllWidgetExecutions,
              scope: objGPWidget<xsl:value-of select="$pWidgetName" />.controler
          });
      }
        </xsl:otherwise>
      </xsl:choose>

      objGPWidget<xsl:value-of select="$WidgetType" />Container =
          objGPWidget<xsl:value-of select="$pWidgetName" />;

    </script>
  </xsl:template>
  <!-- printWidgetExecution END  -->

  <!-- drawWidgets START  -->
  <xsl:template name="geoextux_redliningpanel:drawWidgets">
    <xsl:param name="pContainer" />

    <xsl:variable name="WidgetType">
      <xsl:text>geoextux_redliningpanel</xsl:text>
    </xsl:variable>

	if (typeof(objGPWidget<xsl:value-of select="$WidgetType" />Container) != 'undefined' &amp;&amp; typeof(<xsl:value-of select="$pContainer" />) != 'undefined')
    {
        if(<xsl:value-of select="$pContainer" />['ctype']){
            <xsl:value-of select="$pContainer" />.add(
                objGPWidget<xsl:value-of select="$WidgetType" />Container
            );
        } else {
            <xsl:value-of select="$pContainer" />.items.push(
                objGPWidget<xsl:value-of select="$WidgetType" />Container
            )
        }
    }
  </xsl:template>
  <!-- drawWidgets END  -->

</xsl:stylesheet>
