<?xml version="1.0" encoding="utf-8"?>
<!-- 
   Copyright (c) 2009- Boreal - Information Strategies, published under the BSD license.
   See http://geoprisma.org/license for the full text of the license.
 --> 
<xsl:stylesheet version="1.0" xmlns:php="http://php.net/xsl"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:dyn="http://exslt.org/dynamic"
    xmlns:zoomslider="http://geoprisma.org/zoomslider"
    extension-element-prefixes="dyn">

  <xsl:output method="html" indent="yes" encoding="utf-8" omit-xml-declaration="yes"/>
  <xsl:namespace-alias stylesheet-prefix="php" result-prefix="xsl" />

<!-- 
     Function : printWidgetSource

     Print the source code for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="zoomslider:printWidgetSource">  
                
    <link rel="stylesheet" type="text/css" >
      <xsl:attribute name="href" >
        <xsl:value-of select="$g_widgets_url"/>
        <xsl:text>/zoomslider/zoomslider.css</xsl:text>
      </xsl:attribute>
    </link>

   </xsl:template>

<!-- 
     Function : printWidgetExecution

     Print the execution code for this widget
-->
  <!-- Call for each widget name-->
  <xsl:template name="zoomslider:printWidgetExecution">
    <xsl:param name="pWidgetName" />
    <xsl:param name="pMapName" />

    <!-- get draw mode  -->
    <xsl:variable name="pDrawMode">
      <xsl:value-of select="$drawmode" />
    </xsl:variable>

    <!-- javascript START -->
    <script type="text/javascript">
      <!-- Quick reference to the Map object -->
      oMap = objGPWidget<xsl:value-of select="$pMapName"/>;

      objGPWidget<xsl:value-of select="$pWidgetName" /> = new GeoExt.ZoomSlider({
        map: oMap,
        vertical: true,
        height: 100,
        x: 17,
        y: 90,
        plugins: new GeoExt.ZoomSliderTip({
      <xsl:if test="$g_locale = 'fr_CA'">
            'template': '<div>Niveau de zoom: {zoom}</div>' +
                        '<div>Résolution: {resolution}</div>' +
                        '<div>Échelle: 1 : {scale}</div>'
      </xsl:if>
        })
      });

      if (typeof(window.objGPWidgetMapPanel<xsl:value-of select="$pMapName"/>) !== "undefined") {
          objGPWidgetMapPanel<xsl:value-of select="$pMapName"/>.add(objGPWidget<xsl:value-of select="$pWidgetName" />);
      }
    </script>
    <!-- javascript END -->
  </xsl:template>

<!-- 
     Function : drawWidget

     Output the widget depending on the render type
-->
  <!-- Call for each widget name -->
  <xsl:template name="zoomslider:drawWidget">
    <xsl:param name="pWidgetName" />
      objGPWidget<xsl:value-of select="$pWidgetName" />
  </xsl:template>


<!--
    Function: getWidgetDepedencies

    Return the list of dependencies for this widget
-->
  <!-- Call for each widget type-->
  <xsl:template name="zoomslider:getWidgetDepedencies">

  </xsl:template>

</xsl:stylesheet>
