<?php
/**
* Factory pour le acl
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/
    
/**
* Factory pour le acl
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage ACL
* @author     Pascal Martin
*/
class org_geoprisma_acl_ACLFactory extends com_borealis_foundation_manager_Factory
{
    /**
    * Construit une nouvelle instance de org_geoprisma_acl_ACLFactory
    * Force l'utilisation de la méthode getACL 
    * 
    * @return org_geoprisma_acl_ACLFactory
    */
    private function __construct() 
    {
        // vide
    }
    
    /**
    * Return a ACL
    * 
    * @return org_geoprisma_acl_ACL
    */
    public static function getACL()
    {
        $objFactory = new org_geoprisma_acl_ACLFactory(); 
        return $objFactory->getManager(org_geoprisma_SettingImpl::getACLClass());
    }
    
    /**
    * Vérifie que l'object passer est un instance de org_geoprisma_config_Config
    * 
    * @param object $pobjManager object to test
    * 
    * @return bool
    */            
    protected function isGoodInstance($pobjManager)
    {
        return $pobjManager instanceof org_geoprisma_acl_ACL;  
    }
    
    /**
    * Retourne une erreur
    * 
    * @param string $pstrMessage Message erreur
    * 
    * @return org_geoprisma_exception_BadConfigException
    */
    protected function getError($pstrMessage)
    {
        return new org_geoprisma_exception_BadConfigException($pstrMessage);   
    }  
}
    
    
?>