<?php
/**
* Exception lancé quand la configuration est mal remplie. 
* La fichier de configuration est invalide, vérifier le path
* 
* Exception code 402
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Exception lancé quand la configuration est mal remplie. 
* La fichier de configuration est invalide, vérifier le path
* 
* Exception code 402
*  
* @category   PHP 
* @package    GeoPrisma
* @subpackage Exception
* @author     Pascal Martin
*/
class org_geoprisma_exception_BadXMLConfigFileException extends Exception
{
    /**
    * @var string
    */
    private $m_strFilePath = '';
    
    /**
    * Construit une nouvelle instance de org_geoprisma_exception_BadXMLConfigFile
    * 
    * @param string $pstrFilePath File path
    * @param string $pstrMessage  Message d'erreur
    * 
    * @return org_geoprisma_exception_BadXMLConfigFile
    */
    public function __construct($pstrFilePath, $pstrMessage)
    {   
        com_borealis_foundation_util_Assert::assertIsString($pstrFilePath);
        com_borealis_foundation_util_Assert::assertIsString($pstrMessage); 
           
        parent::__construct($pstrMessage, 402);
        $this->m_strFilePath = $pstrFilePath;
    }   
    
    /**
    * Return the file path
    * 
    * @return string 
    */
    public function getFilePath()
    {
        return $this->m_strFilePath;
    }
}
  
?>