<?php
/**
* Classe de base des layout, Lier aux fichier de configuration
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Classe de base des layout, Lier aux fichier de configuration 
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Service 
* @author     Pascal Martin 
*/ 
class org_geoprisma_layout_Layout
{
    private $m_strName = null;
    private $m_strFile = null;
    private $m_strDrawMode = null;
    
    /**
    * Construit un instance de org_geoprisma_service_Service
    * 
    * @param string $pstrName     Layout name
    * @param string $pstrFile     Layout path
    * @param string $pstrDrawMode Layout draw mode 
    * 
    * @return org_geoprisma_service_Service
    */
    public function __construct($pstrName, $pstrFile, $pstrDrawMode) 
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrName);
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrFile);
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrDrawMode);
        
        $this->m_strName = $pstrName;
        $this->m_strFile = $pstrFile;
        $this->m_strDrawMode = $pstrDrawMode; 
    }

    /**
    * Layout name
    *
    * @return string
    */
    public function getName()
    {
        return $this->m_strName;   
    }
    
    /**
    *  Layout path
    *
    * @return string
    */
    public function getFile()
    {
        return $this->m_strFile;
    }   

    /**
    *  Layout Draw Mode
    *
    * @return string
    */
    public function getDrawMode()
    {
        return $this->m_strDrawMode;
    }
}

?>
