<?php
/**
* Class Proxy de type widget
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy de type widget
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Proxy 
* @author     Pascal Martin 
*/     
class org_geoprisma_proxy_config_ConfigProxy extends org_geoprisma_proxy_Proxy
{
    /**
    * @var org_geoprisma_config_Config
    */
    private $m_objConfig = null;

    private $m_strMethod = null;
    
    /**
    * Creates an instance of org_geoprisma_proxy_config_ConfigProxy
    * 
    * @param org_geoprisma_config_Config $pobjConfig  Config
    * @param string                      $pstrProcess Process
    * 
    * @return org_geoprisma_proxy_config_ConfigProxy
    */
    public function __construct(
        org_geoprisma_config_Config $pobjConfig,
        $pstrProcess
    ) {
        $this->m_objConfig = $pobjConfig;
        $this->m_strMethod = $pstrProcess;

        try
        {
            if (count($pobjConfig->getProcessList()) == 0) 
            {
                throw new Exception("The \"".get_class($objConfig)."\" config driver doesn't support any osmprocess value.");

            }
            else if (!in_array($pstrProcess, $pobjConfig->getProcessList())) 
            {
                throw new Exception("osmprocess param has an invalid value.  Possible values are : ".implode(", ", $pobjConfig->getProcessList()));

            }
        }
        catch (Exception $objException)
        {
            $this->echoJsonError($objException->getMessage());
            exit();
        }
    }
    
    /**
    * Retourne le nom de l'action réaliser par le proxy (Create - Read - Update - Delete)
    *                                   
    * @return string
    */
    public function getAction() 
    {
        return null;
    }

    /**
    * Call the widget method
    * 
    * @return void
    */
    public function process()
    {
        try
        {
            $this->echoJsonResult(
                call_user_func(array($this->m_objConfig, $this->m_strMethod))
            );
        }
        catch (Exception $objException)
        {
            $this->echoJsonError($objException->getMessage());
        }
    }
    
    /**
    * Retourne la liste de layer accèder par la query
    * 
    * @return ArrayObject
    */
    public function getLayers()
    {
        return null;
    }
}
  
?>
