<?php
/**
* Class Proxy de type feature server
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy de type feature server 
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Proxy 
* @author     Pascal Martin 
*/   
abstract class org_geoprisma_proxy_featureserver_FeatureServerProxy extends org_geoprisma_proxy_Proxy
{
    const PATH_INFO_REG = '/^\/([a-zA-Z0-9_]+)\/?(([0-9]*|all)\.?(GeoJSON|json|kml|atom|gml)?)$/i';
    const PATH_INFO_LAYER_POS = 1;
    const PATH_INFO_ID_POS = 3;
    
    /**
    * Return Layer
    * 
    * @return string
    */
    public function getLayer()
    {
        $strPathInfo = self::getPathInfo();
        $objArrayMatches = array();
        if (preg_match(self::PATH_INFO_REG, $strPathInfo, $objArrayMatches)) 
        {
            return $objArrayMatches[self::PATH_INFO_LAYER_POS];
        }
        return '';        
    }
    
    /**
    * Return data id
    * 
    * @return integer or null
    */
    public static function getID()
    {
        $strPathInfo = self::getPathInfo();
        $objArrayMatches = array();
        if (preg_match(self::PATH_INFO_REG, $strPathInfo, $objArrayMatches) && count($objArrayMatches) >= self::PATH_INFO_ID_POS) 
        {
            $iID = $objArrayMatches[self::PATH_INFO_ID_POS];
            if (is_numeric($iID)) 
            {                
                return (int)$iID;
            }
        }
        return null;        
    }
    
    /**
    * Retourne la liste de layer accèder par la query
    * 
    * @return ArrayObject
    */
    public function getLayers()
    {
        $objArrayLayers = new ArrayObject();
        $strLayer = $this->getLayer();
        if ($strLayer != "") 
        {
            $objArrayLayers->append($strLayer);
        }
        return $objArrayLayers;    
    }
}
  
?>
