<?php
/**
* Class Proxy de type wms
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin 
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Class Proxy de type wms 
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Proxy 
* @author     Pascal Martin 
*/     
class org_geoprisma_proxy_wms_WMSProxy extends org_geoprisma_proxy_Proxy
{
    /**
    * Retourne le nom de l'action réaliser par le proxy (Create - Read - Update - Delete)
    *                                   
    * @return string
    */
    public function getAction()
    {
        return self::CRUD_READ;    
    }

    /**
    * Foward the call end return the result
    * 
    * @return void
    */
    public function process()
    {
        ob_start();
        $objCurl = curl_init($this->addParam($this->getService()->getSource()));                
        curl_exec($objCurl);
        $objArrayInfo = curl_getinfo($objCurl);
        curl_close($objCurl);

        header("Content-type: $objArrayInfo[content_type]");

        if ($this->getCaching()) 
        {
            header("Pragma: public");
            header("Cache-Control: maxage=".$this->getExpires());
            header('Expires: ' . gmdate('D, d M Y H:i:s', time()+$this->getExpires()) . ' GMT');
        }

        ob_end_flush(); 
    }
    
    /**
    * Retourne la liste de layer accèder par la query
    * 
    * @return ArrayObject
    */
    public function getLayers()
    {
        $objArrayLayer = new ArrayObject();
        foreach ($_GET as $strKey => $strValue) 
        {
            if (strtoupper($strKey) == "LAYERS") 
            {
                $objArrayLayer = new ArrayObject(explode(',', $_GET[$strKey]));
            }
        }
        return $objArrayLayer;         
    }

    /**
    * Return true if caching is enabled
    *
    * @return boolean
    */
    public function getCaching()
    {
        return org_geoprisma_SettingImpl::getWMSProxyCaching();
    }

    /**
    * Return expires
    *
    * @return integer
    */
    public function getExpires()
    {
        return org_geoprisma_SettingImpl::getWMSProxyCachingExpires();
    }
}
  
?>
