<?php
/**
* Construit le bon type de widget selon le type de noeud dans la configuration 
* xml
*
* PHP versions 5
* 
* @category  PHP
* @package   GeoPrisma  
* @author    Pascal Martin
* @copyright 2009, Boreal - Information Strategies
* @license   http://www.geoprisma.org/license BSD License
* @link      http://www.geoprisma.org
*/

/**
* Construit le bon type de widget selon le type de noeud dans la configuration 
* xml 
* 
* @category   PHP 
* @package    GeoPrisma
* @subpackage Widget 
* @author     Pascal Martin
* @license    http://www.geoprisma.org/license BSD License
* @link       http://www.geoprisma.org
*/ 
class org_geoprisma_widget_WidgetFactory
{

    /**
    * Retourne un widget
    * 
    * @param string $pstrType  Service type
    * @param array  $pobjArray Config array
    * 
    * @return org_geoprisma_widget_Widget
    */
    static public function getWidget($pstrType, $pobjArray)
    {
        com_borealis_foundation_util_Assert::assertIsNotEmptyString($pstrType);
        
        switch($pstrType)
        {
            case org_geoprisma_widget_MapWidget::MAP_WIDGET:
                return new org_geoprisma_widget_MapWidget($pobjArray);
                break;
            case org_geoprisma_widget_MapFishLayerTreeWidget::MAP_FISH_LAYER_TREE_WIDGET:
                return new org_geoprisma_widget_MapFishLayerTreeWidget(
                    $pobjArray
                );
                break;
            case 'generic':
                $strType = (string)$pobjArray->type;
                return new org_geoprisma_widget_GenericWidget(
                    $strType, $pobjArray
                );
                break;            
            default:
                return new org_geoprisma_widget_GenericWidget(
                    $pstrType, $pobjArray
                ); 
        }
    }

}

?>
