<?php
    
class org_geoprisma_proxy_widget_WidgetProxyTest extends PHPUnit_Framework_TestCase
{

    public function testProcess()    
    {
        $_REQUEST['osmservice'] = 'WidgetService';
        $_REQUEST['osmresource'] = 'RessourceMerge'; 
    
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();  
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_widget_WidgetProxy);               

        ob_start();
        $objProxy->process();    
        $strResult = ob_get_contents();
        ob_end_clean();    
        $objResult = json_decode($strResult);
        $this->assertEquals(false, $objResult->success);
        $this->assertEquals(false, $objResult->reload); 
        $this->assertEquals(Merge::getText('i18n_select_two_feature_messagebox_msg'), $objResult->message);            
    }
    
    /**
    * @expectedException Exception 
    */ 
    public function testProcess2()    
    {
        $_REQUEST['osmservice'] = 'WidgetService';
        $_REQUEST['osmresource'] = 'RessourceMergeBAD'; 
    
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();  
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_widget_WidgetProxy);               
    }
    
    /**
    * @expectedException Exception 
    */
    public function testProcess3()    
    {
        $_REQUEST['osmservice'] = 'WidgetService';
        $_REQUEST['osmresource'] = 'RessourceMergeBadMethod'; 
    
        $objProxy = org_geoprisma_proxy_ProxyFactory::getProxy();  
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_Proxy); 
        $this->assertTrue($objProxy instanceof org_geoprisma_proxy_widget_WidgetProxy);  
        
        $objProxy->process();                
    }
    
    public function testGetLayers()    
    {
        $objArrayLayers = org_geoprisma_proxy_widget_WidgetProxy::getLayers(); 
        $this->assertTrue($objArrayLayers instanceof ArrayObject);
        $this->assertEquals(0, count($objArrayLayers));                   
    }
        
}
  
?>