<?php
    
class org_geoprisma_service_ServiceFactoryTest extends PHPUnit_Framework_TestCase
{

    public function testGetService()    
    {
        $strXML = ' <wms>
                      <name>MetaCartaVM0</name>
                      <srs>*</srs>
                      <format>*</format>
                      <source>http://labs.metacarta.com/wms/vmap0</source>
                    </wms>';
        $objSimpleXmlElement = simplexml_load_string($strXML);
        $objService = org_geoprisma_service_ServiceFactory::getService('wms', $objSimpleXmlElement);     
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_WMSService);      
        $this->assertEquals('MetaCartaVM0', $objService->getName());
    }  
    
    public function testGetService2()    
    {
        $strXML = ' <featureserver>
                      <name>FeatureServerDemo</name>
                      <source>http://featureserver.org/demo/featureserver.cgi</source>
                    </featureserver>';
        $objSimpleXmlElement = simplexml_load_string($strXML);
        $objService = org_geoprisma_service_ServiceFactory::getService('featureserver', $objSimpleXmlElement);     
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_FeatureServerService);     
        $this->assertEquals('FeatureServerDemo', $objService->getName());
    }  
    
    /**
    * @expectedException Exception 
    */
    public function testGetService3()    
    {
        $strXML = ' <featureserver>
                      <name>FeatureServerDemo</name>
                      <source>http://featureserver.org/demo/featureserver.cgi</source>
                    </featureserver>';
        $objSimpleXmlElement = simplexml_load_string($strXML);
        org_geoprisma_service_ServiceFactory::getService('AMDSAISFJI', $objSimpleXmlElement);              
    }  
    
    public function testGetService4()    
    {
        $strXML = ' <featureserver>
                      <source>http://featureserver.org/demo/featureserver.cgi</source>
                    </featureserver>';
        $objSimpleXmlElement = simplexml_load_string($strXML);
        $objService = org_geoprisma_service_ServiceFactory::getService('featureserver', $objSimpleXmlElement);     
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_FeatureServerService);     
        $this->assertEquals('', $objService->getName()); 
    } 
    
    public function testGetService5()    
    {
        $strXML = ' <widget>
                        <name>WidgetService</name>
                    </widget>';
        $objSimpleXmlElement = simplexml_load_string($strXML);
        $objService = org_geoprisma_service_ServiceFactory::getService('widget', $objSimpleXmlElement);     
        $this->assertTrue($objService instanceof org_geoprisma_service_Service);
        $this->assertTrue($objService instanceof org_geoprisma_service_WidgetService);     
        $this->assertEquals('WidgetService', $objService->getName()); 
    }  
     
}
  
?>